<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.12.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>kmCpu: ReadMe</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">kmCpu
   </div>
   <div id="projectbrief">kmCpu library for AVR</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.12.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search',true);
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('md__x_1_2_r_e_a_d_m_e.html',''); initResizable(true); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div><div class="header">
  <div class="headertitle"><div class="title">ReadMe</div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1>kmCpu library for AVR MCUs</h1>
<p>The kmCPU library offers a set of functions to control CPU operations and peripherals on AVR MCUs</p>
<h2>Table of Contents</h2>
<ul>
<li>Version History</li>
<li>Overview</li>
<li>Dependencies</li>
<li>Usage</li>
<li>Example Code</li>
<li>Author and License</li>
</ul>
<h2>Version History</h2>
<p>v1.0.0 Initial (2024-05-25)</p>
<h2>Overview</h2>
<p>Includes:</p><ul>
<li>Functions to enable and disable interrupts (<code><a class="el" href="km_cpu_8h.html#a0091ca9e864da5359580d4a9e7b828d9">kmCpuInterruptsEnable()</a></code>, <code><a class="el" href="km_cpu_8h.html#a89ffdd67aa53e2885528d1b820513386">kmCpuInterruptsDisable()</a></code>).</li>
<li>Watchdog management functions to enable, disable, and reset the watchdog timer (<code>kmCpuWatchdogEnable()</code>, <code>kmCpuWatchdogDisable()</code>, <code>kmCpuWatchdogReset()</code>).</li>
<li>Additional functions for halting the CPU (<code>kmCpuHalt()</code>), performing a soft reset (<code>kmCpuSoftReset()</code>), and disabling watchdog and interrupts on startup (<code>kmCpuDisableWatchdogAndInterruptsOnStartup()</code>).</li>
</ul>
<h2>Dependencies</h2>
<ul>
<li><a href="https://gitlab.com/c-mos/kmAvrLibs/kmCommon">kmCommon</a></li>
</ul>
<h2>Usage</h2>
<p>Getting this library and adding it to own project:</p><ul>
<li>To add this module to own project as submodule - enter the main directory of the source code and use git command</li>
</ul>
<div class="fragment"><div class="line"> bash</div>
<div class="line">git submodule add git@gitlab.com:c-mos/kmAvrLibs/kmCpu.git kmCpu</div>
</div><!-- fragment --><ul>
<li>After cloning own application from git repository use following additional git command to get correct revision of submodule: <div class="fragment"><div class="line"> bash</div>
<div class="line">git submodule update --init</div>
</div><!-- fragment --></li>
</ul>
<h3>Interrupt Control</h3>
<p>Use the functions <code><a class="el" href="km_cpu_8h.html#a0091ca9e864da5359580d4a9e7b828d9">kmCpuInterruptsEnable()</a></code> and <code><a class="el" href="km_cpu_8h.html#a89ffdd67aa53e2885528d1b820513386">kmCpuInterruptsDisable()</a></code> to respectively enable and disable interrupts.</p>
<h3>Watchdog Management</h3>
<p>Manage the watchdog timer using the functions <code>kmCpuWatchdogEnable()</code>, <code>kmCpuWatchdogDisable()</code>, and <code>kmCpuWatchdogReset()</code> to enable, disable, and reset the watchdog timer.</p>
<h3>CPU Operations</h3>
<p>Utilize functions like <code>kmCpuHalt()</code> to halt the CPU, <code>kmCpuSoftReset()</code> to perform a software reset, and <code>kmCpuDisableWatchdogAndInterruptsOnStartup()</code> to disable watchdog and interrupts on startup.</p>
<h2>Example Code</h2>
<div class="fragment"><div class="line"><span class="preprocessor">#include &quot;kmCommon/kmCommon.h&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">void</span>) {</div>
<div class="line">    <span class="comment">// Init interrupts and watchdog</span></div>
<div class="line">    <a class="code hl_function" href="km_cpu_8h.html#a0091ca9e864da5359580d4a9e7b828d9">kmCpuInterruptsEnable</a>();</div>
<div class="line">    kmCpuWatchdogEnable(WDTO_2S);</div>
<div class="line"> </div>
<div class="line">    <span class="keywordflow">while</span> (<span class="keyword">true</span>) {</div>
<div class="line">        kmCpuWatchdogReset();</div>
<div class="line">    }</div>
<div class="line">}</div>
<div class="ttc" id="akm_cpu_8h_html_a0091ca9e864da5359580d4a9e7b828d9"><div class="ttname"><a href="km_cpu_8h.html#a0091ca9e864da5359580d4a9e7b828d9">kmCpuInterruptsEnable</a></div><div class="ttdeci">void kmCpuInterruptsEnable(void)</div><div class="ttdef"><b>Definition</b> kmCpu.h:45</div></div>
</div><!-- fragment --><h2>Author and License</h2>
<p>Author: Krzysztof Moskwa</p>
<p>e-mail: chris[dot]moskva[at]gmail[dot]com</p>
<p>Software License: GNU General Public License (GPL) version 3.0 or later. See <a href="https://www.gnu.org/licenses/gpl-3.0.txt">LICENSE.txt</a></p>
<p><img src="https://www.gnu.org/graphics/gplv3-or-later-sm.png" alt="GPL3 Logo" class="inline"/> </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.12.0 </li>
  </ul>
</div>
</body>
</html>
